--
-- Create tables for MovieDB
--

CREATE TABLE format (
       id    serial,	-- Unique identifier
       name  varchar	-- Name of format
);

CREATE TABLE username (
       id    serial,	-- Unique identifier
       name  varchar	-- Name of user
);

CREATE TABLE movie (
       id	   serial,	-- Unique identifier
       title	   varchar,	-- Title of the movie
       notes	   varchar,	-- Extra information
       format	   int,		-- Movie format
       owner	   int,		-- Owner of the movie
       cuser	   int,		-- Current user
       CONSTRAINT movie_format_fk
		  FOREIGN KEY(format) REFERENCES format(id)
		  ON UPDATE RESTRICT ON DELETE RESTRICT,
       CONSTRAINT movie_owner_fk
		  FOREIGN KEY(owner) REFERENCES username(id)
		  ON UPDATE RESTRICT ON DELETE RESTRICT,
       CONSTRAINT movie_cuser_fk
		  FOREIGN KEY(cuser) REFERENCES username(id)
		  ON UPDATE RESTRICT ON DELETE RESTRICT
);


CREATE INDEX movie_id_index ON movie (id);
-- Index on format not necessary because of few entries.
-- Index on username not necessary because of few entries.
