#ifndef _MOVIE_TABLE_HH
#define _MOVIE_TABLE_HH

#include <TPtrVectorT.hh>
#include "UserTable.hh"
#include "FormatTable.hh"
#include "Table.hh"


class MovieRow
{
public:
  
  MovieRow ()
  {
    format_index = 0;
    owner_index = 0;
    cuser_index = 0;
  }
  
  TString id;
  TString title;
  TString notes;
  TString format_id;
  TString owner_id;
  TString cuser_id;
  
  /* These are copies from UserTable and FormatTable. */
  TString format;
  TString owner;
  TString cuser;
  
  /* Indexes into UserTable and FormatTable for above copies. */
  int format_index;
  int owner_index;
  int cuser_index;
};


class MovieTable : public Table
{
public:
  
  virtual ~MovieTable () { rows.ClearAndDestroy (); }
  
  /**
   * Select rows from database.
   * The display field in utable and ftable is used in the select.
   */
  void Select (UserTable& utable, FormatTable& ftable,
	       bool sort_by_insert_order);
  
  void Delete (int row);
  
  /**
   * Update row.
   */
  void Update (MovieRow& mrow);
  
  /**
   * Insert row.
   */
  void Insert (MovieRow& mrow);
  
  TPtrVectorT<MovieRow> rows;
};

#endif // _MOVIE_TABLE_HH
