#include <TValHashSetT.hh>
#include <TDBConnectionManager.hh>
//  #include "UiMain.hh"
#include "NameTable.hh"


void
NameTable::Select ()
{
  TValHashSetT<TString,THashString> set;
  TDBConnection *conn;
  TDBResult *res;
  NameRow *row;
  TString sql ("SELECT * FROM ");
  int n, tuples;
  
  sql += myTableName;
  sql += " ORDER BY name ASC";
  
  /* Save display variable in hash set. */
  n = rows.Entries ();
  for (int i = 0; i < n; i++)
    {
      if (! rows[i]->display)
	set.Insert (rows[i]->id);
    }
  
  /* Remove all old rows from vector. */
  rows.ClearAndDestroy ();
  map.Clear ();
  
  conn = TDBConnectionManager::Connection ();
  if (conn->IsValid ())
    {
      res = conn->Execute (sql);
      if (res->IsValid ())
	{
	  tuples = res->Tuples ();
	  for (int i = 0; i < tuples; i++)
	    {
	      row = new NameRow ();
	      row->id   = res->Value(i, 0);
	      row->name = res->Value(i, 1);
	      
	      /* Read value of display from hash set. */
	      if (set.Contains (row->id))
		row->display = false;
	      
	      rows.Append (row);
	      map.Insert (row->id, i);
	    }
	  
	  SelectedRowsMessage (tuples);
	}
      else
	myErrorMessages.Append (res->ErrorMessage ());
      
      delete res;
    }
  else
    myErrorMessages.Append (conn->ErrorMessage ());
}


void
NameTable::Delete (int row)
{
  TString sql ("DELETE FROM ");
  
  sql += myTableName;
  sql += " WHERE id=";
  sql += rows[row]->id;
  
  Execute (sql);
}


void
NameTable::Update (NameRow& row)
{
  TString sql ("UPDATE ");
  
  sql += myTableName;
  sql += " SET name='";
  sql += QuoteString (row.name);
  sql += "' WHERE id=";
  sql += row.id;
  
  Execute (sql);
}


void
NameTable::Insert (NameRow& row)
{
  TString sql ("INSERT INTO ");
  
  sql += myTableName;
  sql += " (name) VALUES ('";
  sql += QuoteString (row.name);
  sql += "')";
  
  Execute (sql);
}


bool
NameTable::IsToDisplayAll ()
{
  int entries = rows.Entries (), n = 0;
  
  for (int i = 0; i < entries; i++)
    if (rows[i]->display)
      n++;
  
  return (n == entries);
}
