#ifndef _NAME_TABLE_HH
#define _NAME_TABLE_HH

#include <TValHashMapT.hh>
#include <TPtrVectorT.hh>
#include <TString.hh>
#include <THashString.hh>
#include "Table.hh"


class NameRow
{
public:

  NameRow (bool allocate_strings = false)
  {
    display = true;
  }
  
  TString id;
  TString name;
  
  /* Display in UI flag */
  bool display;
};


class NameTable : public Table
{
public:
  
  virtual ~NameTable () { rows.ClearAndDestroy (); }
  
  /**
   * Select rows from database.
   */
  void Select ();
  
  void Delete (int row);
  
  void Update (NameRow &row);
  
  void Insert (NameRow &row);
  
  /**
   * Query if all rows are to be displayed in the UI.
   */
  bool IsToDisplayAll ();
  
  /* Rows selected from the database. */
  TPtrVectorT<NameRow> rows;
  
  /* Used to map database row IDs against index numbers in rows vector. */
  TValHashMapT<TString,int,THashString> map;
  
protected:
  
  /* Assign in sub class! */
  TString myTableName;
};

#endif // _NAME_TABLE_HH
