#include <stdio.h>
#include "UiList.hh"

using namespace Gtk;


UiList::UiList (int columns)
  : CList (columns),
    myNumRows (0),
    myNumSelectedRows (0)
{
  set_shadow_type (GTK_SHADOW_IN);
  set_selection_mode (GTK_SELECTION_EXTENDED);
  
  for (int i = 0; i < columns; i++)
    {
      set_column_title (i, "Empty");
      column_title_passive (i);
    }
  
  column_titles_show();
}


void
UiList::Append (const gchar **row)
{
  rows().push_back (row);
  myNumRows++;
  mySelectedRows.Resize (myNumRows, false);
}


void
UiList::Clear ()
{
  rows().clear ();
  myNumRows = 0;
  myNumSelectedRows = 0;
  mySelectedRows.Resize (0);
}


TValListT<int>*
UiList::GetSelectedRows ()
{
  TValListT<int> *list = new TValListT<int>;
  
  int n = mySelectedRows.Entries ();
  for (int i = 0; i < n; i++)
    {
      if (mySelectedRows[i])
	list->Append (i);
    }
  
  return list;
}


void
UiList::select_row_impl(gint p0, gint p1, GdkEvent* p2)
{
  if (! mySelectedRows[p0])
    myNumSelectedRows++;
  
  mySelectedRows[p0] = true;
  CList::select_row_impl (p0, p1, p2);
}


void
UiList::unselect_row_impl(gint p0, gint p1, GdkEvent* p2)
{
  if (mySelectedRows[p0])
    myNumSelectedRows--;
  
  mySelectedRows[p0] = false;
  CList::unselect_row_impl (p0, p1, p2);
}
