#ifndef _UI_LIST_HH
#define _UI_LIST_HH

#include <gtk--/clist.h>
#include "TValListT.hh"
#include "TValVectorT.hh"


/**
 * List widget.
 */

class UiList : public Gtk::CList
{
public:
  
  /**
   * Construct list.
   *
   * @param columns  Number of columns
   */
  UiList (int columns);
  
  /**
   * Append row to list.
   */
  void Append (const gchar **row);
  
  /**
   * Clear list.
   */
  void Clear ();
  
  /**
   * Get the number of selected rows.
   */
  int GetNumSelectedRows () { return myNumSelectedRows; }
  
  /**
   * Get a list with all selected rows.
   * The list should be destroyed after use.
   */
  TValListT<int>* GetSelectedRows ();
  
  
private:
  
  /**
   * Called when a row is selected.
   */
  void select_row_impl(gint p0, gint p1, GdkEvent* p2);
  
  /**
   * Called when a row is unselected.
   */
  void unselect_row_impl(gint p0, gint p1, GdkEvent* p2);
  
  
  /* Number of rows in list. */
  int myNumRows;
  
  /* Number of selected rows at the moment. */
  int myNumSelectedRows;
  
  /* A vector the size of the list, mapping those entries that are selected. */
  TValVectorT<bool> mySelectedRows;
};

#endif // _UI_LIST_HH
