#include <gtk--/label.h>
#include <gtk--/table.h>
#include "UiMovieForm.hh"


UiMovieForm::UiMovieForm ()
  : myTitleEntry (200),
    myNotesEntry (200)
{
  Gtk::Table *table;
  Gtk::Label *label1, *label2, *label3, *label4, *label5;
  
  myTitleEntry.set_editable (true);
  myNotesEntry.set_editable (true);
  
  table = manage (new Gtk::Table (5, 2));
  table->set_col_spacing (0, 5);
  
  label1 = manage (new Gtk::Label ("Title", 0));
  label2 = manage (new Gtk::Label ("Notes", 0));
  label3 = manage (new Gtk::Label ("Format", 0));
  label4 = manage (new Gtk::Label ("Owner", 0));
  label5 = manage (new Gtk::Label ("User", 0));
  
  table->attach (*label1, 0, 1, 0, 1);
  table->attach (*label2, 0, 1, 1, 2);
  table->attach (*label3, 0, 1, 2, 3);
  table->attach (*label4, 0, 1, 3, 4);
  table->attach (*label5, 0, 1, 4, 5);
  
  myVBox.pack_start (*table, true, true);
  
  table->attach (myTitleEntry, 1, 2, 0, 1);
  table->attach (myNotesEntry, 1, 2, 1, 2);
  table->attach (myFormatMenu, 1, 2, 2, 3);
  table->attach (myOwnerMenu, 1, 2, 3, 4);
  table->attach (myUserMenu, 1, 2, 4, 5);
  
  label1->show ();
  label2->show ();
  label3->show ();
  label4->show ();
  label5->show ();
  
  myTitleEntry.show ();
  myNotesEntry.show ();
  
  myFormatMenu.show ();
  myOwnerMenu.show ();
  myUserMenu.show ();
  
  table->show ();
}


void
UiMovieForm::SetData (MovieRow& mrow, UserTable& utable, FormatTable& ftable)
{
  int i, entries;
  
  myTitleEntry.set_text (mrow.title.Data ());
  myNotesEntry.set_text (mrow.notes.Data ());
  
  myOwnerMenu.Clear ();
  myUserMenu.Clear ();
  myFormatMenu.Clear ();
  
  entries = utable.rows.Entries ();
  for (i = 0; i < entries; i++)
    {
      myOwnerMenu.Append (utable.rows[i]->name);
      myUserMenu.Append (utable.rows[i]->name);
    }
  
  entries = ftable.rows.Entries ();
  for (i = 0; i < entries; i++)
    myFormatMenu.Append (ftable.rows[i]->name);
  
  /* Set default row in option menus. */
  myOwnerMenu.SetIndex (mrow.owner_index);
  myOwnerMenu.Update ();
  myUserMenu.SetIndex (mrow.cuser_index);
  myUserMenu.Update ();
  myFormatMenu.SetIndex (mrow.format_index);
  myFormatMenu.Update ();
  
  myTitleEntry.grab_focus ();
}


void
UiMovieForm::GetData (MovieRow& mrow, UserTable& utable, FormatTable& ftable)
{
  mrow.title = myTitleEntry.get_text().c_str();
  mrow.notes = myNotesEntry.get_text().c_str();
  mrow.owner_id = utable.rows[myOwnerMenu.GetIndex()]->id;
  mrow.cuser_id = utable.rows[myUserMenu.GetIndex()]->id;
  mrow.format_id = ftable.rows[myFormatMenu.GetIndex()]->id;
}
