#ifndef _UI_MOVIE_FORM_HH
#define _UI_MOVIE_FORM_HH

#include <gtk--/entry.h>
#include "UiDialog.hh"
#include "UiOptionMenu.hh"
#include "MovieTable.hh"


/**
 * Form used when working towards the movie table.
 */

class UiMovieForm : public UiDialog
{
public:
  
  /**
   * Constructs widget.
   */
  UiMovieForm ();
  
  /**
   * Load widget with data.
   */
  void SetData (MovieRow& mrow, UserTable& utable, FormatTable& ftable);
  
  /**
   * Get data from widget.
   * Is to be used after the OK button have been pressed.
   */
  void GetData (MovieRow& mrow, UserTable& utable, FormatTable& ftable);
  
private:
  
  Gtk::Entry myTitleEntry;
  Gtk::Entry myNotesEntry;
  
  UiOptionMenu myFormatMenu;
  UiOptionMenu myOwnerMenu;
  UiOptionMenu myUserMenu;
};

#endif // _UI_MOVIE_FORM_HH
