#include "UiOptionMenu.hh"


UiOptionMenu::UiOptionMenu ()
  : myIndex (0),
    myNumElements (0)
{
  set_menu (myMenu);
}


void
UiOptionMenu::Append (TString& string)
{
  Gtk::Menu_Helpers::MenuList& list = myMenu.items ();

  list.push_back (Gtk::Menu_Helpers::MenuElem
		  (string.Data (), bind (slot (this, &UiOptionMenu::callback),
					 myNumElements)));
  
  myNumElements++;
}


void
UiOptionMenu::Clear ()
{
  Gtk::Menu_Helpers::MenuList& list = myMenu.items ();
  list.clear ();
  
  myIndex = 0;
  myNumElements = 0;
}


void
UiOptionMenu::SetIndex (int index)
{
  if (index >= 0 && index < myNumElements)
    {
      myMenu.set_active (index);
      myIndex = index;
    }
}


void
UiOptionMenu::Update ()
{
  remove_menu ();
  set_menu (myMenu);
}
