#ifndef _UI_OPTION_MENU_HH
#define _UI_OPTION_MENU_HH

#include <gtk--/menu.h>
#include <gtk--/optionmenu.h>
#include "TString.hh"


/**
 * Simplified option menu widget.
 */

class UiOptionMenu : public Gtk::OptionMenu
{
public:
  
  /**
   * Construct widget.
   */
  UiOptionMenu ();
  
  /**
   * Append entry to menu.
   */
  void Append (TString& string);
  
  /**
   * Clear all entries.
   */
  void Clear ();
  
  /**
   * Get selected entry.
   */
  inline int GetIndex () { return myIndex; }
  
  /**
   * Select default entry.
   */
  void SetIndex (int index);
  
  /**
   * Make menu visible.
   * This method should be called after having added your entries
   * to the menu to make it visible.
   */
  void Update ();
  
private:
  
  /**
   * Callback for selection in the menu.
   */
  void callback (int index) { myIndex = index; }
  
  /* Selected index. */
  int myIndex;
  
  /* Number of elements in menu. */
  int myNumElements;
  
  /* Menu inside option menu. */
  Gtk::Menu myMenu;
};

#endif // _UI_OPTION_MENU_HH
